/******************************************************************************
 *                                                                            *
 * File:   scanflag.c         Version  1.10            Date: 2000-06-03       *
 *                                                                            *
 * Copyright (C) 2000 by Kostis Netzwerkberatung                              *
 * Talstr. 25, D-63322 Rdermark, Tel. +49 6074 881056, FAX 881058            *
 * kosta@kostis.net (Kosta Kostis), http://www.kostis.net/                    *
 *                                                                            *
 ******************************************************************************
 *                                                                            *
 * History:                                                                   *
 *     2000-06-03: KK V1.10                                                   *
 *        - initial coding                                                    *
 *                                                                            *
 *****************************************************************************/

#include <stdio.h>
#include <string.h>

#include "scanflag.h"

/******************************************************************************

	Function Variables

 *****************************************************************************/

#define	L_MAXPATH		254

char	FileName	[L_MAXPATH + 1] ;	/* registry query filename */
int	DEBUG ;					/* debug flag */

/******************************************************************************

	Function:
		parse parameters

	Parameter:
		int		argc		# of parameters
		char		*argv	[]	parameters

	Returns:
		SCANFLAG_OK			all parameters valid

		SCANFLAG_UNKNOWN		unknown parameter
		SCANFLAG_BADARGS		illegal parameter(number)

 *****************************************************************************/

int	ScanFlag
(
	int		argc,
	char		*argv	[]
)
{
	int		i ;
	int		parms		= 0 ;	/* yet no parameter scanned */

	/**********************************************************************

		set defaults

	 *********************************************************************/

	strcpy (FileName, "") ;
	DEBUG = SCANFLAG_NO ;

	for (i = 1 ; i < argc ; ++i)	/* scan parameters */
	{
		/**************************************************************

			is it a flag/switch (*NIX style)?

		 *************************************************************/

		if (*argv [i] == '-')
		{
			/******************************************************

				which flag?

			 *****************************************************/

			switch (argv [i][1])
			{
				case	'd':	/* debug flag */

					if (DEBUG == SCANFLAG_YES)
						return (SCANFLAG_COMBINED) ;

					if (strcmp (argv [i], "-debug") == 0)
					{
						DEBUG = SCANFLAG_YES ;
						break ;
					}

					return (SCANFLAG_UNKNOWN) ;

				default:        /* unknown flag		*/

					return (SCANFLAG_UNKNOWN) ;
			}
		}
		else
		{
			/******************************************************

				is not a flag, got to be a filename

			 *****************************************************/

			++parms ;	/* copy	filename */
			switch (parms)
			{
				case	1:

					strcpy (FileName, argv [i]) ;
					break ;

				default :

					return (SCANFLAG_BADARGS) ;
			}
		}
	}

	/**********************************************************************

		everything's great, let's return

	 *********************************************************************/

	return (SCANFLAG_OK) ;
}
